include: '/polls/.poll.yml'

variables:
  MANIFEST_URL:
    value: 'https://github.com/96boards/oe-rpb-manifest.git'
    description: 'Manifest repository'
  MANIFEST_BRANCH:
    value: 'qcom/master'
    description: ''
  CACHE_REPO_DIR:
    value: '$CI_PROJECT_DIR/repo/$MANIFEST_BRANCH'
    description: ''
  CONFIGS_PIPELINE_TRIGGER: 'oe'

.oe-poll:
  before_script: |
    set -ex
    if [ ! -d $CACHE_REPO_DIR ]; then
      mkdir -p $CACHE_REPO_DIR
      pushd $CACHE_REPO_DIR
      repo init -u $MANIFEST_URL -b $MANIFEST_BRANCH
      popd
    fi

    # previous sync may lead the working directory 'dirty' so discard any changes
    pushd $CACHE_REPO_DIR/.repo/repo
    git status
    git diff
    git checkout -f
    popd

    # sync and generate latest file
    pushd $CACHE_REPO_DIR
    repo sync --verbose
    repo manifest --revision-as-HEAD > $LATEST
    popd

    # pass the manifest branch to the (possible) triggered pipeline
    export TRIGGER_VAR_MANIFEST_BRANCH=$MANIFEST_BRANCH
  extends:
    - .poll
  cache:
    key: $CI_JOB_NAME
    paths:
      - $CACHE_REPO_DIR/.repo
      - $CACHE
